/*   special_module.h  -  simple class to have an internal module treated like
 *                          a plugin and appear in Special menu
 *
 *   Copyright (C) 1995-2002 by Boulder Laboratory for 3-Dimensional Electron
 *   Microscopy of Cells ("BL3DEMC") and the Regents of the University of 
 *   Colorado.  See implementation file for full copyright notice.
 */                                                                           

/*  $Author: mast $

$Date: 2006/02/13 05:11:03 $

$Revision: 1.3 $

$Log: special_module.h,v $
Revision 1.3  2006/02/13 05:11:03  mast
Added mouse function

Revision 1.2  2004/09/24 18:08:34  mast
Added message execution function

Revision 1.1  2003/10/01 05:08:32  mast
Initial creation

*/

#ifndef SPECIAL_CLASS_H
#define SPECIAL_CLASS_H

#ifndef IMODP_H
typedef struct ViewInfo ImodView;
#endif
class QStringList;

class QKeyEvent;
class QMouseEvent;
typedef char *(*SpecialInfo)(int *);
typedef void (*SpecialExecuteType)(ImodView *, int, int);
typedef int (*SpecialExecuteMessage)(ImodView *, QStringList *, int *);
typedef void (*SpecialExecute)(ImodView *);
typedef int (*SpecialKeys)(ImodView *, QKeyEvent *);
typedef int (*SpecialMouse)(ImodView *, QMouseEvent *, float, float,
                        int, int, int);

class SpecialModule
{
 public:
  SpecialInfo mInfo;
  SpecialExecuteType mExecuteType;
  SpecialExecuteMessage mExecuteMessage;
  SpecialExecute mExecute;
  SpecialKeys mKeys;
  SpecialMouse mMouse;
};

#endif
